DEFAULT = 'en'                   #default language
LANGUAGES = ['en','fr','ja']     #available languages

from ExtensionClass import Base
from string import split
from Globals import get_request
from OFS.SimpleItem import Item

## non-functional solution to avoid get_request
## from webdav.NullResource import NullResource

## def __bobo_traverse__(self, REQUEST, name=None):
##     # stick the request somewhere here for later use
##     # by __getattr__ if needed...
##     self.aq_base._v_REQUEST = REQUEST

##     try: return getattr(self, name)
##     except AttributeError: pass
##     try: return self[name]
##     except KeyError: pass
##     method=REQUEST.get('REQUEST_METHOD', 'GET')
##     if not method in ('GET', 'POST'):
##         return NullResource(self, name, REQUEST).__of__(self)

##     # Waaa. unrestrictedTraverse calls us with a fake REQUEST.
##     # There is proabably a better fix for this.
##     try: REQUEST.RESPONSE.notFoundError("%s\n%s" % (name, method))
##     except AttributeError:
##         raise KeyError, name

def __getattr__(self, name):
    """Magically get the translated attribute - be very fast if possible"""
    if name[0] == '_':
        return Base.__getattr__(self, name)
#    req = self._v_REQUEST
    req = get_request() 
#        if not req:  lacking this doesn't seem to break anything, so bum the cycles
#            return Base.__getattr__(self, name)
    lang = req.get('language',None)
    if not lang:
        langs = split(req.get_header('HTTP_ACCEPT_LANGUAGE',''), ',')
        for lang in langs:
            lang = split(lang,'-')[0]   #don't do dialects right now
            if lang in LANGUAGES:
                break
        else:
            lang=DEFAULT
        req.set('language',lang) # for speed
    
    attr = "%s__%s" % (lang, name)
    if self.__dict__.has_key(attr):
        return self.__dict__[attr]
    else:
        attr = "%s__%s" % (DEFAULT, name)
        if self.__dict__.has_key(attr):
            return self.__dict__[attr]
        else:
            return Base.__getattr__(self, name)

#Item.__bobo_traverse__ = __bobo_traverse__
Item.__getattr__ = __getattr__
